#include <Wire.h>
#include <VL53L0X.h>
//#include <MedianFilter.h>
//
//MedianFilter test1(3, 2000);
//MedianFilter test2(3, 2000);
//MedianFilter test3(3, 2000);

#define LONG_RANGE
//#define HIGH_SPEED
//#define HIGH_ACCURACY

//#include <SoftwareSerial.h>

VL53L0X sensor;
VL53L0X sensor2;
VL53L0X sensor3;

int x=0;

byte y = 0;



//SoftwareSerial mySerial(A4, A5); // RX, TX
void setup()
{
  pinMode(A1, OUTPUT);
  pinMode(A2, OUTPUT);
  pinMode(A3, OUTPUT);

  digitalWrite(A1, LOW);
  digitalWrite(A2, LOW);
  digitalWrite(A3, LOW);

  delay(500);
  Wire.begin();
  

  //SENSOR
  pinMode(A3, INPUT);
  delay(150);
  sensor.init(true);
  delay(100);
  sensor.setAddress((uint8_t)22);

  //SENSOR 2
  pinMode(A2, INPUT);
  delay(150);
  sensor2.init(true);
  delay(100);
  sensor2.setAddress((uint8_t)25);

  //SENSOR 3
  pinMode(A1, INPUT);
  delay(150);
  sensor3.init(true);
  delay(100);
  sensor3.setAddress((uint8_t)28);

  sensor.setTimeout(500);
  sensor2.setTimeout(500);
  sensor3.setTimeout(500);

  // lower the return signal rate limit (default is 0.25 MCPS)

  Serial.begin(115200);

#if defined LONG_RANGE
  // lower the return signal rate limit (default is 0.25 MCPS)
  sensor.setSignalRateLimit(0.17);
  // increase laser pulse periods (defaults are 14 and 10 PCLKs)
  sensor.setVcselPulsePeriod(VL53L0X::VcselPeriodPreRange, 15);
  sensor.setVcselPulsePeriod(VL53L0X::VcselPeriodFinalRange, 11);

  // lower the return signal rate limit (default is 0.25 MCPS)
  sensor2.setSignalRateLimit(0.17);
  // increase laser pulse periods (defaults are 14 and 10 PCLKs)
  sensor2.setVcselPulsePeriod(VL53L0X::VcselPeriodPreRange, 15);
  sensor2.setVcselPulsePeriod(VL53L0X::VcselPeriodFinalRange, 11);

  // lower the return signal rate limit (default is 0.25 MCPS)
  sensor3.setSignalRateLimit(0.17);
  // increase laser pulse periods (defaults are 14 and 10 PCLKs)
  sensor3.setVcselPulsePeriod(VL53L0X::VcselPeriodPreRange, 15);
  sensor3.setVcselPulsePeriod(VL53L0X::VcselPeriodFinalRange, 11);

#endif

#if defined HIGH_SPEED
  // reduce timing budget to 20 ms (default is about 33 ms)
  sensor.setMeasurementTimingBudget(20000);

#elif defined HIGH_ACCURACY
  // increase timing budget to 200 ms
  sensor.setMeasurementTimingBudget(200000);

#endif
}
void loop()
{

  int L = constrain(sensor.readRangeSingleMillimeters(), 0, 1200);
  int Ls = map(L, 0, 1200, 100, 0);


  int M = constrain(sensor2.readRangeSingleMillimeters(), 0, 1200);
  int Ms = map(M, 0, 1200, 100, 0);

  int R = constrain(sensor3.readRangeSingleMillimeters(), 0, 1200);
  int Rs = map(R, 0, 1200, 100, 0);


  //  Serial.print(Ls);
  //  Serial.print(" ");
  //
  //  Serial.print(Ms);
  //  Serial.print(" ");
  //
  //  Serial.println(Rs);


  int sen[2];
  sen[1]=0;
  sen[2]=0;

  

  if ((L < 1000) && (R < 1000))
  {
    if ((L < 1000) && (M < 1000) && (R < 1000))
    {
      sen[1] = 6;
    }
    else
    {
      sen[1] = 7;
    }
  }
  else {
    if (L < 1000) {
      if ((L < 1000) && (M < 1000))
      {
        sen[1]  = 2;
      }

      else {
        sen[1] = 1;
      }
    }
    else if (R < 1000) {
      if ((R < 1000) && (M < 1000))
      {
        sen[1] = 4;
      }
      else {
        sen[1] = 5;
      }

    }
    else if (M < 1000) {
      sen[1] = 3;
    }
  }



  if ((L < M) && (L < R))
  {
    sen[2] = Ls;
  }
  else if ((M < R) && (M < L))
  {
    sen[2] = Ms;
  }
  else if ((R < M) && (R < L))
  {
    sen[2] = Rs;
  }
  Wire.beginTransmission(4); // transmit to device #4
  Wire.write(sen[1]);        // sends five bytes
  Wire.write(sen[2]);              // sends one byte  
  Wire.endTransmission();    // stop transmitting
  Serial.print(sen[1]);
  Serial.print(" ");
  Serial.println(sen[2]);
  delay(10);

  
}
